# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/Reference/00_crdt.ipynb.

# %% auto 0
__all__ = ['Key', 'Rights', 'CRDTp']

# %% ../nbs/Reference/00_crdt.ipynb 4
Key = TypeVar("Key", bound=tuple[Site, str])

class Rights(UserDict[Key, DAG]):
    "Class gathering rights"
    def __setitem__(self, key: Key, value: DAG):
        super().__setitem__(key, value)
        for item in self.values():
            item.rights = self
        for node in value.nodes:
            value.nodes[node]["key"] = key

    @property
    def nodes(self):
        return list(dict.fromkeys(flatten([list(j) for j in [i.nodes for i in self.values()]])))

    def draw(self):
        for key in self.keys():
            graph = DAG(self.get(key))
            graph.draw()

# %% ../nbs/Reference/00_crdt.ipynb 5
@dataclass
class CRDTp:
    """Class rights and document operations
    
    Parameters
    ----------
    site_from
        site this CRDT acts as"""
    site_from: Site
    num = 0
    ac_dags: Rights = field(repr=False, default_factory=Rights)  # access control dags
    waiting_pool: List[Op] = field(repr=False, default_factory=list)
    
    def __post_init__(self):
        for right in ["admin", "write", "read"]:
            self.ac_dags[self.site_from.label, right] = DAG(key=(self.site_from.label, right))
            
    def _ensure_tuple_is_present(self, key) -> DAG | None:
        try:
            return self.ac_dags[key]
        except KeyError:
            self.ac_dags[key] = DAG(key=key)
            return None

# %% ../nbs/Reference/00_crdt.ipynb 6
@patch
def prepare(self: CRDTp,
            site_to: Site,  # Targeted `crdt.sites.Site`
            right: Literal["admin", "write", "read"]  # Targeted right
        ) -> Op:  # Operation pending integration
    """Creates an operation pertaining to one site and right (an access tuple) without integrating it
    
    To integrate it, use `CRDTp.effect`.
    """
    deps = ["0"]
    sign = "-"  # type: Literal["+", "-"]
    key = (site_to.label, right)
    if dag := self._ensure_tuple_is_present(key):  # cas où le tuple d'accès existe déjà
        deps = [op for op in dag._level_nodes(dag._longest_valid_path_length()) if dag._get_valide(op)]
        sign = self.ac_dags[key]._get_sign(deps[0])

    self.num += 1  # le numéro d'opération émise par le site courant est global
    return Op(site_from=self.site_from, site_to=site_to, num=self.num, right=right, sign=sign, deps=deps)

# %% ../nbs/Reference/00_crdt.ipynb 7
@patch
def effect(self: CRDTp,
           op: Op  # Operation to be integrated
          ) -> List[Op] | None:  # List of integrated `crdt.op.Op` (op + waiting)
    """Integrates an operation"""
    ret = []
    self._ensure_tuple_is_present(op.tuple)

    # condition réutilisée plusieurs fois
    deps_ok: Callable[[Op], bool] = lambda _op: all([str(dep) in self.ac_dags[_op.tuple].pol for dep in _op.deps])

    # si toutes les deps d'op n'ont pas déjà été intégrées, on met en attente
    if not deps_ok(op):
        self.waiting_pool.append(op)  # mise en attente
        return None  # ! pas de signal si en attente
    elif op in self.waiting_pool:
        self.waiting_pool.remove(op)

    # on applique l'effet
    self.ac_dags[op.tuple].add_op(
        str(op),
        [str(dep) for dep in op.deps],
        last=str(op.last),
        missing=[str(dep) for dep in op.missing] if op.missing else None,
    )
    ret += [op]

    # on applique l'effet des successeurs en attente
    if any(deps_ok(ready_successor := waiting) for waiting in self.waiting_pool) and (
        successor_ret := self.effect(  # type: ignore
            ready_successor
        )  # la récursivité nous permet de ne pas avoir à rafraîchir `self.waiting_pool` à chaque itération de ce qui auraît autrement pû se faire via une boucle
    ):
        ret += successor_ret

    return ret  # ! liste de tuples (opération intégrée, validité lors de l'intégration)
